unit Umain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type

  TfrmMain = class(TForm)
    pLeft: TPanel;
    pClient: TPanel;
    moInfo: TMemo;
    btnConnect: TButton;
    Label1: TLabel;
    gbServType: TRadioGroup;
    Label2: TLabel;
    btnCreateFormul: TButton;
    Label3: TLabel;
    Label4: TLabel;
    btnSetData: TButton;
    moData: TMemo;
    cbFormatuj: TCheckBox;
    cbPrzelicz: TCheckBox;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    cbPokazOkno: TCheckBox;
    cbReadOnly: TCheckBox;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Label8: TLabel;
    cbPrintPrev: TCheckBox;
    cbPrintForm: TCheckBox;
    Bevel3: TBevel;
    cbGetData: TCheckBox;
    Label9: TLabel;
    Bevel4: TBevel;
    edtswformul: TEdit;
    procedure btnConnectClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnCreateFormulClick(Sender: TObject);
    procedure btnSetDataClick(Sender: TObject);
    procedure ControlClick(Sender: TObject);
  private
    { Private declarations }
    // ktry z programw uruchamiamy ?
    Formserw: boolean;
    // Uchwyt naszej dll-ki
    FhSf32: THandle;
    // Uchwyt do okna servera formularzy
    FhServ: THandle;
    FSvFormul: string;
    // Identyfikator formularza
    FFormulIdent: integer;

    {***** Private declarations SF32  *****}
    // Zmienne do przechowywania funkcji eksportowanych z biblioteki
    // opis przeznaczenia i parametrw w pliku sterform.html
    // FormulExists index 9
    Sf32FormulExists:   function(): bool; stdcall;
    // LoadSerwer index 10
    Sf32LoadSerwer:     function(): word; stdcall;
    // FreeSerwer index 11
    Sf32FreeSerwer:     procedure; stdcall;
    // FormVersion index 12
    Sf32FormVersion:    function():longint; stdcall;
    // CreateFormul index 13
    Sf32CreateFormul:   function(symbol,
                                 identyfikator:pChar;
                                 param:longint):longint; stdcall;
    // DeleteFormul index 14
    Sf32DeleteFormul:   function(formul:longint;
                                 param:longint):boolean; stdcall;
    // OpenWidokFormul index 15
    Sf32OpenWidokFormul:function(formul:longint;
                                 opis:pChar;
                                 parent:hWnd;
                                 param:longint):word; stdcall;
    // SetTextFormul index 16
    Sf32SetTextFormul:  function(formul:longint;
                                 tx:pChar;
                                 formatuj,
                                 przelicz:bool):longint; stdcall;
    // GetTextFormul index 17
    Sf32GetTextFormul:  function(formul:longint;
                                 tx:pChar;
                                 maxTx:longint;
                                 konwertuj:bool):longint; stdcall;
    // OpenWydrukFormul index 18
    Sf32OpenWydrukFormul: function(formul:longint;
                                 opis:pChar;
                                 parent:hWnd;
                                 var odStr, doStr:word;
                                 param:longint):bool; stdcall;
    // PrintFormul index 19
    Sf32PrintFormul:    function(formul:longint;
                                 opis:pChar;
                                 parent:hWnd;
                                 odStr, doStr:word;
                                 param:longint):bool; stdcall;
    // SetStrukPodDoch index 20
    Sf32SetStrukPodDoch: function(formul:longint;
                                 struk:pChar):longint; stdcall;
    // BylWydruk index 21
    Sf32BylWydruk:      function(formul:longint;
                                 var odStr, doStr:word):bool; stdcall;
    // BylaZmiana index 22
    Sf32BylaZmiana:  function(formul:longint):bool; stdcall;
    // DeleteFormul2 index 23
    Sf32DeleteFormul2:  function(formul:longint;
                                 param:longint):bool; stdcall;
    // OpenWydrukFormul_C index 24
    Sf32OpenWydrukFormul_C: function(formul:longint;
                                 opis:pChar; parent:hWnd;
                                 odStr,doStr:PWord;
                                 param:longint):bool; stdcall;
    // BylWydruk_C index 25
    Sf32BylWydruk_C: function(formul:longint;
                                 odStr, doStr:PWord):bool; stdcall;
    // PrintFormulToPrinter index 26
    Sf32PrintFormulToPrinter: function(formul:longint;
                                 opis:pChar;
                                 parent:hWnd;
                                 odStr, doStr:word;
                                 param:longint;
                                 printerIndex:Integer):boolean stdcall;
    // LoadSerwerFree index 27
    Sf32LoadSerwerFree: function(path:PChar):word; stdcall;
    // OpenWidokFormul32 index 28
    Sf32OpenWidokFormul32: function(formul:longint;
                                 opis:pChar;
                                 parent:hWnd;
                                 param:longint):dword; stdcall;
    {***** End Private declarations SF32  *****}

    function GetConnected: boolean;

    // Aktualizacja fornatki
    procedure FormUpdate;
    // Aktualizacja moInfo
    procedure AddInfo(sText: String);
    function MyBoolToStr(val: boolean):string;

    function Connect(DllPath: string; ServerDir: string = ''): boolean;
    procedure Disconnect;

  public
    { Public declarations }
    // Czy mamy prawidowe poaczenie z Dll i Serwerkiem
    property Connected: boolean read GetConnected;

  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

function IsDir(const APath: string): string;
begin
  Result:= Trim(APath);
  if Result <> '' then
    if Result[Length(Result)]<>'\'then
      Result:= Result+'\';
end;

function  KillProc(const hWnd: THandle):Boolean;
  var
    pid:DWORD;
    hProc: THandle;
begin
  Result:=False;

  if hWnd = 0 then
  begin
    Result:=True;
    Exit;
  end;

  if IsWindow(hWnd) then begin
    GetWindowThreadProcessId(hWnd, @pid);
    hproc := OpenProcess(PROCESS_TERMINATE, FALSE, pid);
    if hproc<>0 then begin
      Result:=TerminateProcess(hProc,0);
      if Result then CloseHandle(hProc);
    end;
  end;
end;

{**************************  TfrmMain  ****************************************}

const
  DllFileName =            'STERF32.dll';
  FormserwFileName =       'FORMSERW.EXE';
  ServerMinVersion = 5;
  // Nazwy procedur eksportowanych z dll
  {index 9} FormulExistsProcName =      'FormulExists';
  {index 10}LoadSerwerProcName =        'LoadSerwer';
  {index 27}LoadSerwerFreeProcName =    'LoadSerwerFree';
  {index 12}FormVersionProcName =       'FormVersion';
  {index 11}FreeSerwerProcName =        'FreeSerwer';
  {index 13}CreateFormulProcName =      'CreateFormul';
  {index 14}DeleteFormulProcName =      'DeleteFormul';
  {index 23}DeleteFormul2ProcName =     'DeleteFormul2';
  {index 15}OpenWidokFormulProcName =   'OpenWidokFormul';
  {index 28}OpenWidokFormul32ProcName = 'OpenWidokFormul32';
  {index 16}SetTextFormulProcName =     'SetTextFormul';
  {index 17}GetTextFormulProcName =     'GetTextFormul';
  {index 18}OpenWydrukFormulProcName =  'OpenWydrukFormul';
  {index 24}OpenWydrukFormul_CProcName = 'OpenWydrukFormul_C';
  {index 19}PrintFormulProcName =       'PrintFormul';
  {index 26}PrintFormulToPrinterProcName = 'PrintFormulToPrinter';
  {index 20}SetStrukPodDochProcName =   'SetStrukPodDoch';
  {index 21}BylWydrukProcName =         'BylWydruk';
  {index 25}BylWydruk_CProcName =       'BylWydruk_C';
  {index 22}BylaZmianaProcName =        'BylaZmiana';
  {index 29}GetListaPolFormulProcName = 'GetListaPolFormul';

  {Parametry dla funkcji OpenWidokFormul}
  ow_bezEdycji = $40;
  ow_pytajOZapisanie = $80;

function TfrmMain.MyBoolToStr(val: boolean): string;
begin
  if val then
    Result:= 'Tak'
  else
    Result:= 'Nie';
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  // Niestety zmienne nie zawsze s inicjalizowane :(
  FhSf32:= 0;
  FhServ:= 0;
  FFormulIdent:=0;

  FormUpdate;
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  Disconnect;
end;

function TfrmMain.GetConnected: boolean;
begin
  Result:= (FhSf32 > 0)and(FhServ > 0);
end;

procedure TfrmMain.ControlClick(Sender: TObject);
begin
  FormUpdate;
end;

procedure TfrmMain.AddInfo(sText: String);
begin
  with moInfo.Lines do
  begin
    BeginUpdate;
    try
      Append(sText);
    finally
      EndUpdate;
    end;
  end;
end;

procedure TfrmMain.FormUpdate;
 var sEnabled: boolean;
begin
  if Connected then
    btnConnect.Caption:='Zwolnij serwer'
  else
    btnConnect.Caption:='aduj serwer';

  gbServType.Enabled:= not Connected;

  // ktry program bdziemy uruchamia
  Formserw:= gbServType.ItemIndex = 1;

  btnCreateFormul.Enabled:= Connected and (FFormulIdent = 0);

  sEnabled:= Connected and (FFormulIdent > 0);
  cbFormatuj.Enabled:= sEnabled;
  cbPrzelicz.Enabled:= sEnabled;
  cbPokazOkno.Enabled:= sEnabled;
  btnSetData.Enabled:=  sEnabled;
  cbPrintPrev.Enabled:= sEnabled;
  cbPrintForm.Enabled:= sEnabled;
  cbGetData.Enabled:=  sEnabled;

  sEnabled:= sEnabled and cbPokazOkno.Checked;
  cbReadOnly.Enabled:= sEnabled;
end;

procedure TfrmMain.btnConnectClick(Sender: TObject);
 var AppDir: string;
begin
  if Connected then
    Disconnect
  else
  begin
    AppDir:=IsDir(ExtractFilePath(Application.ExeName));
    Connect(AppDir+DllFileName, AppDir+'FORMUL.IPS\');
  end;

  FormUpdate;
end;

function TfrmMain.Connect(DllPath: string; ServerDir: string = ''): boolean;
  var
    FunctionExist: boolean;    // czy mamy wskaniki funkcji dll  ?
    ServerExist: boolean;      // czy odnalelimy serwer formularzy ?
    ServerVersionOk: boolean;  // czy prawidowa wersja serwera ?
    ServerVersion: integer;
begin
  Result:= False;
  ServerVersionOk:= false;
  FunctionExist:= false;

  // Czycimy informacje
  moInfo.Clear;

  // aduj bibliotek dll
  FhSf32 := LoadLibrary(PAnsiChar(DllPath));

  try
    if FhSf32 = 0 then
    begin
      // Bd adowania dll, niestety nic wicej nie zrobimy
      AddInfo('Bd adowania '+DllPath);
      RaiseLastOSError();
      Exit;
    end else
      AddInfo('Zaadowano '+DllFileName+' hwnd: '+IntToStr(FhSf32));

    // Pobieramy procedury eksportowane przez dll
    // adowanie procedur po nazwie jest bardziej czytelne dlatego te
    // w caym przykadzie bd si trzyma tej konwencji

    // Jeeli bdziemy wywoywali formips.exe  FormulExists, LoadSerwer
    // dla formserw.exe  LoadFreeSerwer i dla obu  FormVersion, FreeSerwer
    if Formserw then
    begin
      Sf32LoadSerwerFree:= GetProcAddress(FhSf32, LoadSerwerFreeProcName );
      FunctionExist:= @Sf32LoadSerwerFree<>nil;
    end else
    begin
      Sf32FormulExists:=  GetProcAddress(FhSf32, FormulExistsProcName );
      Sf32LoadSerwer:= GetProcAddress(FhSf32, LoadSerwerProcName );
      FunctionExist:= (@Sf32FormulExists <> nil)and(@Sf32LoadSerwer<>nil);
    end;

    Sf32FormVersion:= GetProcAddress(FhSf32, FormVersionProcName );
    Sf32FreeSerwer:=  GetProcAddress(FhSf32, FreeSerwerProcName );
    FunctionExist:= FunctionExist and
                   (@Sf32FormVersion<>nil)and
                   (@Sf32FreeSerwer<>nil);

    if  not FunctionExist then
    begin
      AddInfo('Niewaciwa wersja biblioteki: '+DllPath);
      Exit;
    end;

    // Dla programu Formularze sprawdzamy czy zosta zainstalowany
    // Funkcja FormulExists sprawdza systemowy plik win.ini w poszukiwaniu cieki
    // sekcja   [formularze]
    // klucz    katalog=sciezka_do_programu
    // dla formserw podajemy w parametrze wywoania ciek do katalogu

    if Formserw then
      ServerExist:= FileExists(ServerDir+FormserwFileName)
    else
      ServerExist:= Sf32FormulExists;

    if not ServerExist then
    begin
      AddInfo('Nieodnalazem serwera formularzy.');
      Exit;
    end;

    // adujemy serwer formularzy
    if Formserw then
      FhServ:= Sf32LoadSerwerFree(PAnsiChar(ServerDir))
    else
      FhServ:= Sf32LoadSerwer;

    if FhServ = 0 then
    begin
      AddInfo('Bd adowania serwera formularzy.');
      Exit;
    end else
    begin
      // Jeeli aplikacja wymaga serwera w odpowiedniej wersji
      ServerVersion:=  Sf32FormVersion;
      ServerVersionOk :=ServerVersion >= ServerMinVersion;

      if not ServerVersionOk  then
      begin
        AddInfo('Niewaciwa wersja serwera formularzy: '+#13#10+
                'aktualna: '+IntToStr(ServerVersion)+'  '+
                'wymagana: '+IntToStr(ServerMinVersion));
        Exit;
      end;
    end;

    // pobieramy pozostae procedury z dll

    Sf32CreateFormul:=    GetProcAddress(FhSf32, CreateFormulProcName );
    Sf32DeleteFormul:=    GetProcAddress(FhSf32, DeleteFormulProcName );
    Sf32DeleteFormul2:=   GetProcAddress(FhSf32, DeleteFormul2ProcName );
    Sf32OpenWidokFormul:= GetProcAddress(FhSf32, OpenWidokFormulProcName );
    Sf32OpenWidokFormul32:= GetProcAddress(FhSf32, OpenWidokFormul32ProcName );

    FunctionExist:=(@Sf32CreateFormul <> nil)and(@Sf32DeleteFormul <> nil)and
                   (@Sf32DeleteFormul2 <> nil)and(@Sf32OpenWidokFormul <> nil)and
                   (@Sf32OpenWidokFormul32 <> nil);
    if not FunctionExist then
      Exit;
    Sf32SetTextFormul:=    GetProcAddress(FhSf32, SetTextFormulProcName );
    Sf32GetTextFormul:=    GetProcAddress(FhSf32, GetTextFormulProcName );
    Sf32OpenWydrukFormul:= GetProcAddress(FhSf32, OpenWydrukFormulProcName );
    Sf32OpenWydrukFormul_C:= GetProcAddress(FhSf32, OpenWydrukFormul_CProcName );
    Sf32PrintFormul:=        GetProcAddress(FhSf32, PrintFormulProcName );

    FunctionExist:= FunctionExist and(@Sf32SetTextFormul <> nil)and
                   (@Sf32GetTextFormul <> nil)and(@Sf32OpenWydrukFormul <> nil)and
                   (@Sf32OpenWydrukFormul_C <> nil)and(@Sf32PrintFormul <> nil);
    if not FunctionExist then
      Exit;
    Sf32PrintFormulToPrinter:= GetProcAddress(FhSf32, PrintFormulToPrinterProcName );
    Sf32SetStrukPodDoch:=    GetProcAddress(FhSf32, SetStrukPodDochProcName );
    Sf32BylWydruk:=          GetProcAddress(FhSf32, BylWydrukProcName );
    Sf32BylWydruk_C:=        GetProcAddress(FhSf32, BylWydruk_CProcName );
    Sf32BylaZmiana:=         GetProcAddress(FhSf32, BylaZmianaProcName );

    FunctionExist:= FunctionExist and (@Sf32PrintFormulToPrinter <> nil)and
                   (@Sf32SetStrukPodDoch  <> nil)and(@Sf32BylWydruk <> nil)and
                   (@Sf32BylWydruk_C <> nil) and(@Sf32BylaZmiana <> nil);

    if FunctionExist then
      AddInfo('Zaadowano serwer formularzy wersja: '+
                 IntToStr(ServerVersion)+' hwnd: '+IntToStr(FhServ))
    else
      AddInfo('Niewaciwa wersja biblioteki: '+DllPath);
  finally
    Result:= Connected and ServerVersionOk and FunctionExist;
    if not Result then
      Disconnect;
    FormUpdate;
  end;
end;

procedure TfrmMain.Disconnect;
begin
  // zwalniam serwer
  if FhServ > 0 then
  begin
    if FFormulIdent > 0 then
    begin
      // Zwalniamy zainicjowane formularze
      if Sf32DeleteFormul2(FFormulIdent,0) then
      begin
        FFormulIdent:= 0;
        FSvFormul:= '';
      end;
    end;

    Sf32FreeSerwer;
    Sleep(500);

    // Jeeli z jakiego powodu niepwiodo si zwolnienie serwera
    // "zwalniam" go mniej elegancko
    if IsWindow(FhServ) then
      KillProc(FhServ);

    FhServ:= 0;
    AddInfo('Zwolniono serwer formularzy');
  end;

  // zwalniam dll
  if FhSf32 > 0 then
  begin
    FreeLibrary(FhSf32);
    FhSf32:= 0;
    AddInfo('Zwolniono '+DllFileName);
  end;

  FormUpdate;
end;

{**************************  obsuga formularzy *******************************}

{ Co nas interesuje ?

  function CreateFormul(symbol,identyfikator:pChar; param:longint):longint;

  Tworzc nowy formularz w parametrach wywoania podajemy "symbol wewntrzny"
  nie nazw pliku !!!
  W wikszoci przypadkw symbolem wewntrzynym formularza jest nazwa pliku bez
  rozszerzenia - jednak nie jest to reg, mog by wyjtki w przypadku
  kilku wersji tegosamego wzoru formuarza.
  Moemy odczyta j z pliku formul.ini sekcja [DLL3] aplikacji lub z formularza
  po otworzeniu go programem Formularze lub Druki - "O formularzu"

  W tym programie nie bd tworzy i otwiera kilku formularzy jednczenie
  ogranicz funkcjonalno do jednego.
  Przykad ktrym si zajmiemy to formularz: VZM - 1 wersja 3

  ............................. informacja z pliku formul.ini
  [DLL3]
  1=VZM1_3 <<- To nas interesuje ->>
  ~VZM1~VZM1_3.F_I~VZM-1(3)~VZM-1(3) Wniosek o zwrot niektrych wydatkw
  zwizanych z budownictwem mieszkaniowym poniesionych od dnia 1.05.2004 r.
  ~4~945048259~30~01. US - Urzd skarbowy~Pozostae~131596545~0
  ............................. "O formularzu"
  VZM-1(3) Wniosek o zwrot niektrych wydatkw zwizanych z budownictwem
  mieszkaniowym poniesionych od dnia 1.05.2004 r.
  Opis skrcony: VZM-1(3)
  Symbol wewntrzny: VZM1_3  <<- To nas interesuje ->>
  Symbol rodziny wzorw: VZM1
  Nazwa pliku: VZM1_3.F_I
  ..............................
}
procedure TfrmMain.btnCreateFormulClick(Sender: TObject);
begin
  FSvFormul:= Trim(edtswformul.Text);
  if FSvFormul = '' then
  begin
    AddInfo('Nie okrelono symbolu formularza');
    Exit;
  end;

  FFormulIdent:= Sf32CreateFormul(PAnsiChar(FSvFormul),'',0);

  if FFormulIdent = 0 then
     AddInfo('Bd tworzenia formularza '+FSvFormul)
  else
    AddInfo('Utworzono formularz '+FSvFormul+' ID='+IntToStr(FFormulIdent));

  FormUpdate;
end;

{ Wysyamy dane do formularza
  function SetTextFormul(formul:longint; tx:pChar; formatuj,przelicz:bool):longint;

  na co naley zwrci uwag
  - numeracja pl
    bibliteka akceptuje dwa rodzaje nazewnictwa pl
    a) numery liczbowe
    b) numery tekstowe
    Ad.a Faktyczne numery w postaci liczbowej
       dla pola 51 wyglda to nastpujco:
        p51=5912  <- pole gowne obliczane pa podstawie poniszych podpl
         p250=10
         p251=20
         p252=30
         p253=40
    Ad.b Numery tekstowe
       dla pola 51 wyglda to nastpujco:
        p51=5912  <- pole gowne obliczane pa podstawie poniszych podpl
         p51a=10
         p51b=20
         p51c=30
         p51d=40

    Obie konwencje nazw s dozwolone. Numeracj rzeczywist pl moemy odczyta
    na podstawie wypenionego i zapisanego pliku formularza Nazwa_formularza.fri
    w kaladogu aplikacji. Numery tekstowe widoczne s po otworzeniu formularza i
    wywoaniu opcji "Id do pola"

  - pola tekstowe wielolinijkowe (w naszym formularzu np pole nr 52)
  amanie tekstu - wszystkie pary znakw #13#10 przed wysaniem danych
  naley zamieni na par o kodach #255#254

  - pola skrele (np pola 7 i 8)
  p7=001
  p7=0 <- pierwsze zero oznacza przecznik
      01 dopiero nastpne "O" lub "1" okrelaj ilo i stan przecznikw
      tak wic w polu nr 7 mamy 2 przeczniki z ktrych drugi jest zaznaczony

  p8=0100
  p8=0 100 pole nr 8 zawiera trzy przeczniki a zaznaczono pierwszy

  - pola obliczane i "podpola" (np pole 44 lub 51)
  formularze zawieraj funkcje obliczeniowe i formatujce ktre zalenie
  od zastosowanych parametrw(formatuj, przelicz)
   - przeformatuj dane do postaci wymaganej przez formularz
   - wylicz pola wynikowe
   - przytn wprowadzone kwoty do wymaganych limitw
   pole 51 jest polem wynikowym a dane ktre tam si znajd bd obliczone
   na podstawie pl: p250, p251, p252, p253
   tak wic jeeli jeeli wybralimy opcj przeliczenia formularza
   to nie ma potrzeby wysyania danych do pola 51 gdy i tak warto ta
   zostanie zmieniona na wyliczon przez formularz
}

procedure TfrmMain.btnSetDataClick(Sender: TObject);
  var
    formatuj, przelicz,
    PokazOkno, ReadOnly,
    PrintPrev, PrintFormul,
    GetData,
    BylyModyfikacje,
    BylWydruk: Boolean;
    params: Integer;
    odStr, doStr: word;
    pOdStr, pDoStr: PWord;
    buf: pChar;
begin
  if not Connected then
  begin
    AddInfo('Nie utworzono formularza');
    Exit;
  end;

  // inicjalizacja wybranych ustawie
  formatuj:=  cbFormatuj.Checked;
  przelicz:=  cbPrzelicz.Checked;
  PokazOkno:= cbPokazOkno.Checked;
  ReadOnly:=  cbReadOnly.Checked;
  PrintPrev:= cbPrintPrev.Checked;
  PrintFormul:= cbPrintForm.Checked;
  GetData:=   cbGetData.Checked;
  BylWydruk:= False;
  BylyModyfikacje:= False;
  odStr:= 0;
  pOdStr:= @odStr;
  doStr:= 0;
  pDoStr:= @doStr;

  try
    // Prygotowuj dane dla formularza
    AddInfo('Prygotowuj dane dla formularza'+#13#10+
    ' formatuj = '+MyBoolToStr(formatuj)+', przelicz = '+MyBoolToStr(przelicz));

    if Sf32SetTextFormul(FFormulIdent,PAnsiChar(moData.Text),formatuj,przelicz)=0 then
    begin
      AddInfo('Przekazanie danych do formularza nie powiodo si');
      Exit;
    end;

    if PokazOkno then
    begin
      //function OpenWidokFormul32(formul:longint; opis:pChar; parent:hWnd; param:longint):dword
      if ReadOnly then
        params:= ow_bezEdycji
      else
        params:= ow_pytajOZapisanie;

      if Sf32OpenWidokFormul32(
        FFormulIdent, PAnsiChar(edtswformul.Text),Self.Handle, params)= 0 then
      begin
        AddInfo('Bd wywietlenia okna formularza');
        Exit;
      end;
      // Czy dokonano modyfikacji z poziomu okienka formularza
      BylyModyfikacje:= Sf32BylaZmiana(FFormulIdent);
      // Czy by wywoany wydruk formularza
      BylWydruk:= Sf32BylWydruk_C(FFormulIdent,pOdStr,pDoStr);
    end;

    // Czy pokaza ustawienia wydruku
    if PrintPrev and not BylWydruk then
    begin
      AddInfo('Wywietlam ustawienia wydruku');

      odStr:= 0; doStr:= 0;
      BylWydruk:= Sf32OpenWydrukFormul_C(
        FFormulIdent,PAnsiChar(FSvFormul),Self.Handle,pOdStr,pDoStr,0);
    end;

    // Wydruk formularza - o ile nie zosta wydrukowany z poziomu okna formularza
    if PrintFormul and  not BylWydruk then
    begin
      // Jeeli z poziomu aplikacji chcemy wybra inn ni domylna drkark
      // mona uy funkcji:
      // PrintFormulToPrinter: function(formul:longint;
      //                             opis:pChar;
      //                             parent:hWnd;
      //                             odStr, doStr:word;
      //                             param:longint;
      //                             printerIndex:Integer):boolean stdcall;
      BylWydruk:= Sf32PrintFormul(
        FFormulIdent,PAnsiChar(FSvFormul),Self.Handle,OdStr,DoStr,0);
    end;

    AddInfo(' Byy mdyfikacje = '+MyBoolToStr(BylyModyfikacje));
    if BylWydruk then
      AddInfo(' By wydruk = '+MyBoolToStr(BylWydruk)+
        ' od strony '+IntToStr(odStr)+'  do strony '+IntToStr(doStr))
    else
      AddInfo(' By wydruk = '+MyBoolToStr(BylWydruk));

    // pobieramy zawarto pl z naszego formlarza
    if GetData then
    begin
      GetMem(buf,64000);
      try
        Sf32GetTextFormul(FFormulIdent,buf,64000,true);
        AddInfo('Zawarto pl formularza pobrana funkcj GetTextFormul = '+
          #13#10+Trim(StrPas(buf))+#13#10);
      finally
        FreeMem(buf,64000);
      end;
    end;
  finally
    if FFormulIdent > 0 then
      if Sf32DeleteFormul2(FFormulIdent,0)then
      begin
        FFormulIdent:= 0;
        AddInfo('Zwolniono formularz: '+FSvFormul);
      end else
        AddInfo('Bd zwolnienia formularza: '+FSvFormul);
    FormUpdate;
  end;
end;


end.










